'(
***************************************************************************
*
*
*
*                  HTF3226LF - Feuchte/Temperatur Sensor
*
*                           von Tommesy
*
'**************************************************************************




***************************************************************************
*                            ATMega8 PDIP
*                               __ __
*             (RESET)     PC6  1  *  28   PC5 (ADC5/SCL)
*                         PD0  2     27   PC4 (ADC4/SDA)
*                         PD1  3     26   PC3 (ADC3)
*                         PD2  4     25   PC2 (ADC2)
*                         PD3  5     24   PC1 (ADC1)
*                         PD4  6     23   PC0 (ADC0)    NTC (Temperatur Sesnor)
*                 5V       VCC 7     22 GND   GND
*                GND       GND 8     21 AREF   ---||----GND  Kondensator 100nf an GND
*                         PB6  9     20 AVCC  5V
*                         PB7  10    19   PB5 SCK   LCD Rs
*          Hygro Sensor   PD5  11    18   PB4 MISO  LCD E
*                         PD6  12    17   PB3 MOSI  LCD DB7
*                         PD7  13    16   PB2       LCD DB6
*               LCD DB4   PB0  14____15   PB1       LCD DB5
*
***************************************************************************
*
*  #########   Fuse Bits ATmega8   ##########
*  #########       Lfuse E1        ##########
*  #########       Hfuse D9        ##########
*
*       http://www.engbedded.com/fusecalc/
*
*  Fuse Bits sind so Eingestellt, als whre der Atmega8 Fabrikneu. Also
*  nichts gendert!!!       (Ohne Quartz)
*
**************************************************************************
')

$regfile = "m8def.dat"                                      ' ATMega8
$crystal = 1000000                                          ' 1 MHz

Const Const5 = 0.0048828125                                 ' 5Volt / 1024 (10-Bit-ADC)

'#######  Fr NTC  #################
Dim Adc0 As Word                                            ' Wert vom NTC
Dim Volt0 As Single                                         ' Volt vom NTC
Dim Tempntc As Single                                       'im Tempntc As Single 'Temperatur (celsius) von NTC
Dim Isttemp As Single                                       ' aktuelle Temperatur in Celsius
Dim Letzter_isttemp As Single                               ' Messwert davor
Dim Disp_tempntc As String * 10                             ' zur LCD-Anzeige

'#######  Fr Hygrometer  ###########
Dim Overflows As Word
Dim Fanzeige As Word
Dim Feuchte As Single
Dim Frequenz2 As Long
Dim Calclong As Long


Declare Sub Adc_in
Declare Sub Hygro
Declare Sub Anzeigen


'##########################   TextLCD   ########################
 Config Lcdbus = 4
 Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Portb.4 , Rs = Portb.5
 Config Lcd = 20 * 4
 Cls
 Deflcdchar 1 , 14 , 10 , 14 , 32 , 32 , 32 , 32 , 32       ' creating  Symbol fr Grad Celsius
 Cursor Off

'#########################  Begrung  #########################
   Locate 1 , 7
   Lcd "Wetter"
   Locate 2 , 2
   Lcd "Sensor HTF3226LF"
   Locate 4 , 6
   Lcd "Ver. 1.6"
   Wait 3
'##########################  LCD ENDE  ##########################

Config Pinc.0 = Input                                       'NTC Widerstand/Resistor
Config Adc = Single , Prescaler = Auto , Reference = Avcc

' Timer1 als Counter einrichten
Config Portd.5 = Input : Portd.5 = 0
Config Timer1 = Counter , Edge = Falling , Prescale = 1

Cls


Do

  Call Adc_in
  Call Hygro
  Call Anzeigen

Loop




'(
#################   ADC Lesen         ########################
#################                     ########################
')
Sub Adc_in
 Start Adc
 Letzter_isttemp = Isttemp                                  ' letzten Messwert merken
 Adc0 = Getadc(0)                                           ' NTC
' Adc1 = Getadc(1)
'######################## Umrechnen
 Volt0 = Adc0 * Const5                                      ' NTC
' Volt1 = Adc1 * Const5                                      '
 Tempntc = Volt0 * 10                                       ' in Celsius umrechnen (10mV je Grad ber Null)
 Isttemp = Tempntc                                          ' aktuelle Temperatur am NTC
 Stop Adc
End Sub


'(
#################   Hygrometer    ###########################
#################                 ###########################
')
Sub Hygro
Locate 4 , 20
   Lcd "*"
' Timer1 als Counter einrichten
'Config Portd.5 = Input : Portd.5 = 0
'Config Timer1 = Counter , Edge = Falling , Prescale = 1
On Counter1 Ueberlauf Nosave
Enable Timer1
 Counter1 = 0
 Overflows = 0
 Enable Interrupts                                          '2 Sekunden zaehlen
 Waitms 2002                                                'finetunig
 Disable Interrupts
 Calclong = Overflows * &HFFFF
 Frequenz2 = Calclong + Counter1
 Frequenz2 = Frequenz2 / 2
'################# Umrechnung in Prozent laut Datenblatt vom HTF3226LF
Feuchte = 9600 - Frequenz2
Fanzeige = Feuchte / 15.8
Locate 4 , 20
   Lcd " "
End Sub


'(
##############################################################
#################                     ########################
#################   LCD Ausgabe       ########################
#################   Anzeige           ########################
##############################################################
')
Sub Anzeigen
  ' Cls

   Locate 1 , 1 : Lcd "Thermometer"
   'Disp_tempntc = Fusing(tempntc , "#.##")                  'mit Aufrunde
   'Disp_tempntc = Fusing(tempntc , "&.&&")                  'ohne Aufrunde
   Disp_tempntc = Fusing(tempntc , "&.&")                   'nur eine Stelle hinterm komma
   Locate 1 , 13
   Lcd Disp_tempntc ; Chr(1) ; "C";

   Locate 2 , 1 : Lcd "Hygrometer"
   Locate 2 , 13 : Lcd Fanzeige ; " %"
  Wait 2

End Sub



End

Ueberlauf:
Incr Overflows
Return